#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include <sys/types.h>
#include <sys/statvfs.h>

#include <fcntl.h>

#include <string>
#include <sstream>

#include "general/Directory.hh"

#include "genericAPI/MountPointStatus.hh"
#include "genericAPI/StatVFSDirect.hh"

static const char* class_name = "StatVFSDirect";
using General::Directory;
using GenericAPI::MountPointStatus;

namespace GenericAPI
{
  StatVFSDirect::
  StatVFSDirect( )
  {
  }

  StatVFSDirect::
  ~StatVFSDirect( )
  {
  }

  void StatVFSDirect::
  Init( )
  {
  }

  std::string StatVFSDirect::
  Debug( ) const
  {
    std::ostringstream	msg;

    msg << class_name << ": " << (void*)this;

    return msg.str( );
  }

  int StatVFSDirect::
  StatVFS( const std::string& Filename, buf_type& Buf ) const
  {
    //-------------------------------------------------------------------
    // Check the availability of the filesystem
    //-------------------------------------------------------------------
    if ( MountPointStatus::Status( Filename )
	 == MountPointStatus::STATE_OFFLINE )
    {
      errno = EINTR;
      return -1;
    }
    //-------------------------------------------------------------------
    // Actually stat the file
    //-------------------------------------------------------------------
    return statvfs( Filename.c_str( ), &Buf );
  }

  StatVFSDirect* StatVFSDirect::
  vnew( ) const
  {
    return new StatVFSDirect( );
  }
}
